﻿@using LAP.DomainModels.Entities.Adviser
@{
    var appointmentStatuses = Html.GetEnumSelectList<AppointmentStatusEnum>().Where(m => Convert.ToInt32(m.Value) > 0);
}
@model ClientAppointment
<div class="modal-dialog modal-lg modal-dialog-scrollable" role="document">
    <div class="modal-content">
        <div class="modal-header">
            <h5 class="modal-title">@(Model?.Id > 0 ? "Edit" : "Add") Client Appointment</h5>
            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <i aria-hidden="true" class="ki ki-close"></i>
            </button>
        </div>
        <div class="modal-body">
            <form action="adviser/dashboard/saveclientappointment" class="form fv-plugins-bootstrap fv-plugins-framework" id="AddClientAppointment_form" method="post" data-ajax="true" data-ajax-begin="onFormBegin" data-ajax-complete="SaveEventComplete">
                <input type="hidden" asp-for="Id" />
                <input type="hidden" asp-for="Guid" />
                <input type="hidden" id="btnSubmitId" value="btn_submit_activity" />
                <input type="hidden" name="confirmed" id="confirmed" />
                <div class="row">
                    <div class="col-xl-6">
                        <div class="form-group @(Model?.Id > 0 ?"disabled-div":"")">
                            <label asp-for="Email"></label>
                            <input asp-for="Email" class="form-control form-control-lg @(Model?.Id > 0 ?"disabled":"")">
                            <span asp-validation-for="Email" class="text-danger"></span>
                        </div>
                    </div>
                </div>
                <div class="row">
                    <div class="col-xl-4">
                        <div class="form-group">
                            <label asp-for="FirstName"></label>
                            <input asp-for="FirstName" class="form-control form-control-lg capitalize">
                            <span asp-validation-for="FirstName" class="text-danger"></span>
                        </div>
                    </div>
                    <div class="col-xl-4">
                        <div class="form-group">
                            <label asp-for="MiddleName"></label>
                            <input asp-for="MiddleName" class="form-control form-control-lg capitalize">
                        </div>
                    </div>
                    <div class="col-xl-4">
                        <div class="form-group">
                            <label asp-for="LastName"></label>
                            <input asp-for="LastName" class="form-control form-control-lg capitalize">
                            <span asp-validation-for="LastName" class="text-danger"></span>
                        </div>
                    </div>
                </div>
                <div class="row">
                    <div class="col-xl-4">
                        <div class="form-group">
                            <label asp-for="Date"></label>
                            <div class="input-group date datepicker-control">
                                <input type="text" asp-for="Date" asp-format="{0:MM'/'dd'/'yyyy}" class="form-control form-control-lg datemask">
                                <div class="input-group-append">
                                    <span class="input-group-text">
                                        <i class="far fa-calendar-alt"></i>
                                    </span>
                                </div>
                            </div>
                            <span asp-validation-for="Date" class="text-danger"></span>
                        </div>
                    </div>
                    <div class="col-xl-4">
                        <div class="form-group">
                            <label asp-for="Time"></label>
                            <div class="input-group time" id="Timepicker" data-target-input="nearest">
                                <input asp-for="Time" type="text" value="@Model?.Time.ToString("hh:mm tt")" class="form-control form-control-lg datetimepicker-input" data-target="#Timepicker" data-toggle="datetimepicker" placeholder="hh:mm tt" readonly />
                                <div class="input-group-append" data-target="#Timepicker" data-toggle="datetimepicker">
                                    <span class="input-group-text">
                                        <i class="far fa-clock"></i>
                                    </span>
                                </div>
                            </div>
                            <span asp-validation-for="Time" class="text-danger"></span>
                        </div>
                    </div>
                    <div class="col-xl-4">
                        <div class="form-group">
                            <label asp-for="Subject"></label>
                            <input asp-for="Subject" class="form-control form-control-lg">
                            <span asp-validation-for="Subject" class="text-danger"></span>
                        </div>
                    </div>
                </div>
                <div class="row">
                    <div class="col-xl-4">
                        <div class="form-group @(Model != null && Model.Leads.Any() ?"disabled-div":"")">
                            <label asp-for="Purpose"></label>
                            <select class="form-control form-control-lg @(Model != null && Model.Leads.Any() ?"disabled":"")" asp-for="Purpose" asp-items="Html.GetEnumSelectList<ClientAppointmentPurposeEnum>()">
                            </select>
                            <span asp-validation-for="Purpose" class="text-danger"></span>
                        </div>
                    </div>
                    <div class="col-xl-4">
                        <div class="form-group">
                            <label asp-for="Location"></label>
                            <input asp-for="Location" class="form-control form-control-lg" type="text">
                            <span asp-validation-for="Location" class="text-danger"></span>
                        </div>
                    </div>
                    <div class="col-xl-4">
                        <div class="form-group">
                            <label asp-for="Status"></label>
                            <select class="form-control form-control-lg" asp-for="Status" asp-items="appointmentStatuses">
                            </select>
                            <span asp-validation-for="Status" class="text-danger"></span>
                        </div>
                    </div>
                </div>
                <div id="lead-container">
                    <hr />
                    <div class="d-flex justify-content-between">
                        <div class="flex-grow-1">
                            <h4 class="text-primary">Lead Details</h4>
                        </div>
                        <div class="align-self-center">
                            <button class="btn btn-sm btn-warning font-weight-bold btn-lead-add" type="button"><i class="fas fa-plus"></i>New Lead</button>
                        </div>
                    </div>
                    <table class="table table-sm table-borderless mt-3" style="font-size:14px;" id="lead-table">
                        <tr>
                            <td></td>
                            <td width="25%">First Name</td>
                            <td width="25%">Last Name</td>
                            <td>Email</td>
                            <td width="60px"></td>
                        </tr>
                        @if (Model != null && Model.Leads.Any())
                        {
                            @foreach (var item in Model.Leads.Select((value, i) => new { i, value }))
                            {
                                <tr>
                                    <td class="align-top">
                                        <span class="css-counter"></span>
                                        <input type="hidden" value="@item.value.Id" name="leads[@item.i].Id" id="leads[@item.i].Id" />
                                        <input type="hidden" value="@item.value.Guid" name="leads[@item.i].Guid" id="leads[@item.i].Guid" class="guid" />
                                        <input type="hidden" value="@(item.value.Active ? "true": "false")" name="leads[@item.i].Active" id="leads[@item.i].Active" />
                                    </td>
                                    <td>
                                        <input value="@item.value.FirstName" type="text" class="form-control form-control-sm capitalize required" readonly name="leads[@item.i].FirstName" id="leads[@item.i].FirstName" data-field="First Name" />
                                        <span class="text-danger" data-valmsg-for="leads[@item.i].FirstName" data-valmsg-replace="true"></span>
                                    </td>
                                    <td>
                                        <input value="@item.value.LastName" type="text" class="form-control form-control-sm capitalize required" readonly name="leads[@item.i].LastName" id="leads[@item.i].LastName" data-field="Last Name" />
                                        <span class="text-danger" data-valmsg-for="leads[@item.i].LastName" data-valmsg-replace="true"></span>
                                    </td>
                                    <td>
                                        <input value="@item.value.Email" data-guid="@item.value.Guid" type="text" class="form-control form-control-sm tolowercase required email" readonly name="leads[@item.i].Email" id="leads[@item.i].Email" data-field="Email" maxlength="50" />
                                        <span class="text-danger" data-valmsg-for="leads[@item.i].Email" data-valmsg-replace="true"></span>
                                    </td>
                                    <td>
                                        <div class="display-view">
                                            <button class="btn btn-icon btn-xs btn-lead-edit @(!item.value.Active ? "disabled-div is-lead" :"")" type="button" data-toggle="tooltip" data-html="true" data-original-title="@(!item.value.Active ? "You cannot edit this lead <br /> as invitation already sent" :"Edit")">
                                                <i class="la la-pencil-alt icon-xl text-primary"></i>
                                            </button>
                                            <button class="btn btn-icon btn-xs btn-lead-delete @(!item.value.Active ? "disabled-div is-lead" :"")" type="button" data-toggle="tooltip" data-html="true" data-original-title="@(!item.value.Active ? "You cannot delete this lead <br /> as invitation already sent" :"Delete")">
                                                <i class="la la-trash icon-xl text-danger"></i>
                                            </button>
                                        </div>
                                        <div class="edit-view d-none">
                                            <button class="btn btn-icon btn-xs btn-lead-save" type="button" data-toggle="tooltip" data-original-title="Save">
                                                <i class="la la-save icon-xl text-primary"></i>
                                            </button>
                                            <button class="btn btn-icon btn-xs btn-lead-cancel" type="button" data-toggle="tooltip" data-original-title="Cancel">
                                                <i class="la la-remove icon-xl text-danger"></i>
                                            </button>
                                        </div>
                                    </td>
                                </tr>
                            }
                        }
                    </table>
                </div>
            </form>
        </div>
        <div class="modal-footer">
            <button class="btn btn-primary font-weight-bold" id="btn_submit_activity" onclick='$("#AddClientAppointment_form").submit()'>
                <i class="la la-save"></i> Save
            </button>
        </div>
    </div>
</div>
<style>
    body {
        counter-reset: section;
    }

    .css-counter::before {
        counter-increment: section;
        content: counter(section)".";
    }
</style>
<script type="text/javascript">

    $.validator.addMethod("exist", function (value, element, params) {
        return this.optional(element) || params.filter(x => x === value).length < 2;
    }, "Email Address already exists");
    setTimeout(function () { validateLeads(); }, 0);
    $('.btn-lead-add').click(function (e) {
        if ($("#AddClientAppointment_form").valid()) {
            $("#lead-table input[type='text']").prop("readonly", true);
            $("#lead-table .edit-view").addClass("d-none");
            $("#lead-table .display-view").removeClass("d-none");
            var rowCount = $("#lead-table").find('tr').length - 1;
            var item = { index: rowCount };
            $("#lead-table").append($("#lead-template").tmpl(item));
            validateLeads();
            $("#ActualNoOfLead").val(item.index + 1);
        }
    });
    var purpose = $("#Purpose").val();
    showHideLead();
    $('#Timepicker').datetimepicker({
        stepping: 15,
        ignoreReadonly: true,
        format: 'LT'
    });
</script>